       subroutine toabini1(ifpcor,ikeyee,nang,ncores,ncspvs,nbeta,nqf,
     +            idim8,mesh,qtryc,iptype,nbl,nnlz,a,b,exfact,rpcor,
     +            z,zv,r,rab,rc,rcloc,eee,ruae,
     +            rscore,rsvale,snl,wwnl,title)

c--------------------------------------------------------------------------
c NAME
c toabini1
c
c FUNCTION
c Store various data for later use in uspp2abinit
c
c COPYRIGHT
c Copyright (C) 2005  MT
c This file is distributed under the terms of the
c GNU General Public License

c==============================================================================

      include "abicom.inc"

c Arguments ---------------------------------------------
      integer ifpcor,nang,mesh,ncores,ncspvs,nbeta,nqf,qtryc,idim8
      integer ikeyee(idim3),iptype(idim3),nbl(idim5),nnlz(idim2)
      double precision a,b,exfact,rcloc,rpcor,z,zv
      double precision eee(idim3),rc(idim5),rscore(idim1),
     +       rsvale(idim1),ruae(idim1),r(idim1),rab(idim1),
     +       snl(idim1,idim2),wwnl(idim2)
      character*20 title

c Commons -----------------------------------------------
      integer stderr
      common /files/ stderr

c Local variables ---------------------------------------
      integer ii,jj,kk
      double precision rtest,rpcormax,rpcormin
      double precision pscore(idim1),pscoef(idim8),work(idim1)

c******************************************************************
c BEGIN EXECUTABLE SECTION
c
c Printing out comment
      write(stderr,'(a)') '> USpp->Abinit translator: first call'

c Init various flags
      abierr=0
      abicomment=0
      indbeta=0

c Various scalar data (file header)
      abtitle=title
      abzatm=z
      abzval=zv
      ablmax=nang-1
      abradstp=a
      ablogstp=b

c Test pseudization model
      do ii=1,nbeta
       if (iptype(ii).gt.2) abierr=-1
      enddo
      if (abierr.ne.0) return

c XC functional type
      abexfact=exfact
      if ((exfact.ne. 0.0).and.(exfact.ne.-1.0).and.
     +    (exfact.ne.-2.0).and.(exfact.ne. 5.0)) then
       abierr=-2
       return
      endif

c Spheres radii
      abrcloc=rcloc
      abrcsph=0.d0
      do ii=1,nang
       if(rc(ii).ge.abrcsph) abrcsph=rc(ii)
      enddo

c Test on ifpcor:
c   if ifpcor=-1, impose rpcor to the max. acceptable value
c                 Acceptable value= value for which we get: rsvale+pscore>0
c                 (this test is not totally exact, but "acceptable")
      if ((ifpcor.eq.-1).and.(ncores.gt.0)) then
       abicomment=1
       ifpcor=1
       rpcormin=abrcsph/3.d0
       rpcormax=abrcsph
       rpcor=rpcormax
111    continue
       do ii=1,mesh
        pscore(ii) = rscore(ii)
        work(ii)   = 0.d0
       enddo
       do ii=1,idim8
        pscoef(ii) = 0.d0
       enddo
       call pspcor2(pscore,pscoef,work,rpcor,mesh,r,rab,a,b,3,
     +              nqf,qtryc,idim1,idim8)
       jj=0
       do ii=1,mesh
        if (pscore(ii)+rsvale(ii).lt.0.d0) jj=jj+1
       enddo
       if (jj.gt.0) then
        rpcormax=rpcor
       else
        rpcormin=rpcor
       endif
       if (rpcormax.gt.rpcormin+0.01d0) then
        rpcor=(rpcormin+rpcormax)*0.5d0
        goto 111
       endif
       rpcor=int(100.d0*rpcor)/100.d0-0.01d0
      endif

c Mesh sizes
      abmshsph=1+nint(log(abrcsph/a+1.d0)/b)
      rtest=a*(exp(b*(abmshsph-1))-1.d0)
      if (rtest<abrcsph-1.d-2) abmshsph=abmshsph+1
      abrcsph=a*(exp(b*(abmshsph-1))-1.d0)

      abmshvbr=1+nint(log(rcloc/a+1.d0)/b)
      rtest=a*(exp(b*(abmshvbr-1))-1.d0)
      if (rtest<rcloc-1.d-8) abmshvbr=abmshvbr+1

      abmshprj=max(abmshsph,abmshvbr)

      abmeshmax=mesh

c Angular momenta for basis elements (orbitals)
      ii=0
      do jj=1,nang
       do kk=1,nbl(jj)
        ii=ii+1
        aborb(ii)=jj-1
       enddo
      enddo
      if (ii.ne.nbeta) then
       abierr=-3
       return
      endif
      abbassz=nbeta

c Reference energies
      do ii=1,nbeta
       abeig(ii)=eee(ii)
       abkeyee(ii)=ikeyee(ii)
      enddo

c AE potential
      do ii=1,abmeshmax
       abvae(ii)=ruae(ii)
      enddo

c Core and valence density
      do ii=1,abmeshmax
       abcore(ii)=rscore(ii)
       abvale(ii)=rsvale(ii)
      enddo

c Valence states occupancies
      abnval=ncspvs-ncores
      do ii=1,abnval
       abocc(ii)=wwnl(ncores+ii)
      enddo

c Valence states angular momenta
      do ii=1,abnval
       ablval(ii)=(nnlz(ncores+ii)-100*(nnlz(ncores+ii)/100))/10
      enddo

c Eigenstates of AE Hamiltonian (Snl(j))
       do jj=1,ncspvs-ncores
        do ii=1,idim1
         abaesnl(ii,jj)=snl(ii,ncores+jj)
        enddo
       enddo

      return
      end


c=========================================================================
c=========================================================================

      subroutine toabini2(nbeta,kkbeta,beta,phi,rab,uuu)

c--------------------------------------------------------------------------
c NAME
c toabini2
c
c FUNCTION
c Cancel (or not) beta orthonormalization...
c
c COPYRIGHT
c Copyright (C) 2005  MT
c This file is distributed under the terms of the
c GNU General Public License

c==============================================================================

      include "abicom.inc"

c Arguments ---------------------------------------------
      integer nbeta,kkbeta
      double precision beta(idim1,idim3),uuu(idim3,idim3),
     +                 rab(idim1),phi(idim1,idim3)


c Commons -----------------------------------------------
      integer stderr
      common /files/ stderr

c Local variables ---------------------------------------
      integer ii,jj,kk,mm,option,ios
      logical ex
      double precision intg,ff(idim1)
      character*80 :: line

c******************************************************************
c BEGIN EXECUTABLE SECTION
c
      if (abierr.ne.0) return

c Printing out comment
      if (indbeta.eq.0)
     +write(stderr,'(a)') '> USpp->Abinit translator: second call'

c Look for "uspp2abinit.dat" file and option
      option=0
      inquire(file="uspp2abinit.dat",iostat=ios,exist=ex)
      if ((ios.eq.0).and.(ex)) then
       open(10,file="uspp2abinit.dat",form='formatted')
1001   read(10,'(a)',err=2001,end=2001) line
       if ((line(1:1).ne."#").and.(line(1:1).ne."!")
     +      .and.(line(1:10)=="OPT_ORTHO=")) then
         read(unit=line(11:80),fmt=*) option
       endif
       goto 1001
2001   continue
       close(10)
      endif

c Restore UUU to identity
      if (option.eq.0) then
       do ii=1,nbeta
        do jj=1,nbeta
         uuu(ii,jj)=0.d0
        enddo
        uuu(ii,ii)=1.d0
       enddo
       if (indbeta.eq.0)
     + write (stderr,'(a,2(/,a))')
     +     '> USpp->Abinit translator COMMENT:',
     +     '  - Orthogonalization of projectors',
     +     '    as been canceled...'
      endif

c set UUU to normalize beta
      if (option.eq.2) then
       do ii=1,nbeta
        do jj=1,nbeta
         uuu(ii,jj)=0.d0
        enddo
        do kk=1,kkbeta
         ff(kk)=beta(kk,ii)*phi(kk,jj)
        enddo
        do kk=kkbeta,1,-1
         if (abs(ff(kk))>1.D-14) goto 111
        enddo
111     kk=min(kk,kkbeta)
        call radin(kk,ff,rab,intg,idim1)
        uuu(ii,ii)=1.d0/intg
       enddo
       if (indbeta.eq.0)
     + write (stderr,'(a,/,a)')
     +     '> USpp->Abinit translator COMMENT:',
     +     '  - Projectors have been normalized...'
      endif

      indbeta=indbeta+nbeta

      return
      end


c=========================================================================
c=========================================================================

      subroutine toabini3(kkbeta,nbeta,phi,psi,beta,ttt)

c--------------------------------------------------------------------------
c NAME
c toabini3
c
c FUNCTION
c Store orbitals, psi, phi, beta for later use in uspp2abinit
c
c COPYRIGHT
c Copyright (C) 2005  MT
c This file is distributed under the terms of the
c GNU General Public License

c=========================================================================

      include "abicom.inc"

c Arguments ---------------------------------------------
      integer nbeta,kkbeta
      double precision beta(idim1,idim3),
     +                 phi(idim1,idim3),psi(idim1,idim3),
     +                 ttt(idim3,idim3)

c Commons -----------------------------------------------
      integer stderr
      common /files/ stderr

c Local variables ---------------------------------------
      integer ib,jb,ii,kb
      integer iwork(idim3)
      double precision binv
      double precision dum1(idim1),bbb(idim3,idim3),
     +                 bbbi(idim3,idim3)

c******************************************************************
c BEGIN EXECUTABLE SECTION
c
      if (abierr.ne.0) return

c Printing out comment
      write(stderr,'(a)') '> USpp->Abinit translator: third call'

c Store partial waves Phi, tPhi, tProj
      do ib=1,nbeta
       do ii=1,kkbeta
c        abphi(ii,ib)=psi(ii,ib)
c        abtphi(ii,ib)=phi(ii,ib)
        abphi(ii,ib) =0.d0
        abtphi(ii,ib)=0.d0
        do kb=1,nbeta
         abphi (ii,ib)=abphi (ii,ib)+ttt(ib,kb)*psi(ii,kb)
         abtphi(ii,ib)=abtphi(ii,ib)+ttt(ib,kb)*phi(ii,kb)
        enddo
        abtproj(ii,ib)=beta(ii,ib)
       enddo
      enddo

      abmeshwav=kkbeta

      return
      end


c=========================================================================
c=========================================================================

      subroutine toabini4(ialtcor,rpcor,rspsco,r,rab,b,mesh)

c--------------------------------------------------------------------------
c NAME
c toabini4
c
c FUNCTION
c Compute (or not) pseudo- core density with "AtomPAW"
c pseudization scheme...
c
c COPYRIGHT
c Copyright (C) 2007  MT
c This file is distributed under the terms of the
c GNU General Public License

c==============================================================================

      include "abicom.inc"

c Arguments ---------------------------------------------
      integer ialtcor,mesh
      double precision rpcor,b
      double precision rspsco(idim1),r(idim1),rab(idim1)


c Commons -----------------------------------------------
      integer stderr
      common /files/ stderr

c Local variables ---------------------------------------
      integer ii,icor,ios
      logical ex
      double precision x,y,z,u0,u2,u4
      double precision dndr(mesh),d2ndr(mesh)
      character*80 :: line

c******************************************************************
c BEGIN EXECUTABLE SECTION
c
      if (abierr.ne.0) return

c Printing out comment
      write(stderr,'(a)') '> USpp->Abinit translator: fourth call'

c Look for "uspp2abinit.dat" file and option
      ialtcor=0
      inquire(file="uspp2abinit.dat",iostat=ios,exist=ex)
      if ((ios.eq.0).and.(ex)) then
       open(10,file="uspp2abinit.dat",form='formatted')
3001   read(10,'(a)',err=4001,end=4001) line
       if ((line(1:1).ne."#").and.(line(1:1).ne."!")
     +      .and.(line(1:10)=="OPT_TCORE=")) then
         read(unit=line(11:80),fmt=*) ialtcor
       endif
       goto 3001
4001   continue
       close(10)
      endif

      if (ialtcor.eq.1) then      
       
c      Set index of matching radius       
       do icor = mesh,1,-1
        if (r(icor).lt.rpcor) goto 5001
       enddo
5001   continue
       if (abs(r(icor+1)-rpcor).lt.abs(r(icor)-rpcor)) icor=icor+1
       
c      Compute first and second derivatives of density       
       call nderiv(mesh,b,rab,rspsco,dndr)
       call nderiv(mesh,b,rab,dndr,d2ndr)
       do ii=1,mesh
        dndr(ii) =dndr(ii)*b
        d2ndr(ii)=d2ndr(ii)*b*b
       enddo

c      Compute coefficients of polynom       
       x=rspsco(icor)
       y=dndr(icor)*r(icor)
       z=d2ndr(icor)*r(icor)*r(icor)
       u0= 3*x-9*y/8+z/8
       u2=-3*x+7*y/4-z/4
       u4=   x-5*y/8+z/8

c      Pseudize density       
       do ii=1,icor
        x=(r(ii)/r(icor))**2
        rspsco(ii)=x*(u0+x*(u2+x*u4))
       enddo

c      Print out comment       
       write (stderr,'(a,3(/,a))')
     +     '> USpp->Abinit translator COMMENT:',
     +     '  - A simple (order 6) polynomial has been used',
     +     '    to pseudize core density instead of native',
     +     '    USPP soft pseudization...'

      endif

      return
      end


c=========================================================================
c=========================================================================

      subroutine toabini5(alpha,ddd0,kkbeta,mesh,nbeta,ncores,
     +                    ncspvs,qfunc,rpcor,rspsco,rsvale,snl,
     +                    vloc,vloc0,flname)

c--------------------------------------------------------------------------
c NAME
c toabini5
c
c FUNCTION
c Store pseudo core density and descreened Vloc for later use in uspp2abinit
c Call translation routine USpp2Abinit
c
c COPYRIGHT
c Copyright (C) 2005  MT
c This file is distributed under the terms of the
c GNU General Public License

c==============================================================================

      include "abicom.inc"

c Arguments ---------------------------------------------
      integer kkbeta,mesh,nbeta,ncores,ncspvs
      double precision rpcor
      double precision alpha(idim3,idim2),ddd0(idim3,idim3),
     +                 qfunc(idim1,idim3,idim3),
     +                 rspsco(idim1),rsvale(idim1),
     +                 snl(idim1,idim2),vloc(idim1),vloc0(idim1)
      character*40 flname(6)

c Commons -----------------------------------------------
      integer stderr
      common /files/ stderr

c Local variables ---------------------------------------
      integer ii,jj,kk,ilen1,ilen2
      character*132 abflname,abfltmp

c******************************************************************
c BEGIN EXECUTABLE SECTION
c
      if (abierr.eq.0) then

c Printing out comment
       write(stderr,'(a)') '> USpp->Abinit translator: fifth call'

c Store tcore, tvale, Vloc, Vloc0
       do ii=1,mesh
        abtcore(ii)=rspsco(ii)
        abtvale(ii)=rsvale(ii)
        abvloc(ii) =vloc(ii)
        abvloc0(ii)=vloc0(ii)
       enddo

c Store eigenstates of PAW/US Hamiltonian (Snl(j))
       do jj=1,ncspvs-ncores
        do ii=1,idim1
         abussnl(ii,jj)=snl(ii,ncores+jj)
        enddo
       enddo

c Store "alpha" terms (<USSnl(j)|Beta(i)> terms)
       do jj=1,ncspvs-ncores
        do ii=1,nbeta
         absnlprj(ii,jj)=alpha(ii,ncores+jj)
        enddo
       enddo

c Store "qij(r)" (phi_i(r).phi_j(r)-tphi_i(r).tphi_j(r))
       do jj=1,nbeta
        do ii=1,nbeta
         do kk=1,kkbeta
          abqij(kk,ii,jj)=qfunc(kk,ii,jj)
         enddo
        enddo
       enddo

c Store descreened Dij
       do jj=1,nbeta
        do ii=1,nbeta
         abddd0(ii,jj)=ddd0(ii,jj)
        enddo
       enddo

      endif

c Test if an error was encountered
      if (abierr.ne.0) then
       write (stderr,'(/,a)') '> USpp->Abinit translator ERROR:'
       if (abierr.eq.-1) write (stderr,'(a)')
     +    '   - Input variable iptype>2 not compatible !'
       if (abierr.eq.-2) write (stderr,'(a,f5.1,a,/,a)')
     +    '   - Exchange and correlation functional (exfact=',
     +    abexfact,')','     not compatible with Abinit !'
       if (abierr.eq.-3) write (stderr,'(a)')
     +    '   - Incompatible number of basis elements !'
       write (stderr,'(/,a)') '> No file for Abinit was created !'
       return
      endif

c Test if a comment has to be displayed
      if (abicomment.gt.0) then
       write (stderr,'(/,a)') '> USpp->Abinit translator COMMENT:'
       if (abicomment-10*(abicomment/10).ge.1)
     +  write (stderr,'(a,/,a,/a,f5.2,a,/,a)')
     +  '  - Variable "ipfcor" was -1 in input file;',
     +  '    The program forced the computation of pseudized',
     +  '    core density and set rpcor=',rpcor,' !',
     +  '    (please verify the consistency of this choice...)'
      endif

c Determine file name for Abinit PAW atomic data
      ilen1=0
      ilen2=0
      do ii=1,len(flname(6))
       if (flname(6)(ii:ii).ne.' ') ilen1=ii
       if ((ii.gt.1).and.(ii.le.len(flname(6))-4)) then
        if (flname(6)(ii:ii+4).eq.'.uspp') ilen2=ii-1
       endif
      enddo
      if (ilen2.gt.0) abflname=flname(6)(1:ilen2)//'.abinit.paw'
      if (ilen2.eq.0) abflname=flname(6)(1:ilen1)//'.abinit.paw'
      if (ilen2.gt.0) abfltmp=flname(6)(1:ilen2)//'.abinit.tmp'
      if (ilen2.eq.0) abfltmp=flname(6)(1:ilen1)//'.abinit.tmp'

c Call USPP -> Abinit translator
      write(stderr,'(/,a)')
     +  '> USpp->Abinit translator: launching translation utility'
      call uspp2abi(abflname)

      return
      end
